	function drawButtonClicked() {

		if (boardActive) {
			deactivateBoard();
		} else {
			activateBoard();
		}
	}

	function clearButtonClicked() {
		clear();
		ALL_STROKES = [];
		drawAllStrokes();
	}

	function eraserButtonClicked() {
		lineColor = '';
		clearColorBorders();
		$('#eraseButton').css('border','solid 2px');
	}

	function blueButtonClicked() {
		lineColor = 'blue';
		clearColorBorders();
		$('#blueButton').css('border','solid 2px');
	}
	function redButtonClicked() {
		lineColor = 'red';
		clearColorBorders();
		$('#redButton').css('border','solid 2px');
	}
	function greenButtonClicked() {
		lineColor = 'green';
		clearColorBorders();
		$('#greenButton').css('border','solid 2px');
	}
	function blackButtonClicked() {
		lineColor = 'black';
		clearColorBorders();
		$('#blackButton').css('border','solid 2px');
	}
	function yellowButtonClicked() {
		lineColor = 'yellow';
		clearColorBorders();
		$('#yellowButton').css('border','solid 2px');
	}
	function cyanButtonClicked() {
		lineColor = 'cyan';
		clearColorBorders();
		$('#cyanButton').css('border','solid 2px');
	}
	function brownButtonClicked() {
		lineColor = 'brown';
		clearColorBorders();
		$('#brownButton').css('border','solid 2px');
	}
	function magentaButtonClicked() {
		lineColor = 'magenta';
		clearColorBorders();
		$('#magentaButton').css('border','solid 2px');
	}
	function grayButtonClicked() {
		lineColor = 'gray';
		clearColorBorders();
		$('#grayButton').css('border','solid 2px');
	}
	function whiteButtonClicked() {
		lineColor = 'white';
		clearColorBorders();
		$('#whiteButton').css('border','solid 2px');
	}


	function saveCanvasClicked() {

		localStoreCanvasForPage(currentPage);

//		saveCanvas(canvas,'canvas','png');

		saveJSONBoard(ALL_STROKES, currentPage);
	}

	function loadCanvasClicked(file) {

		console.log(file);

		$('#file-input').click();
	}


	function loadButtonClicked() {

		$('#dialogDiv').dialog({
			autoOpen: true,
			height: 200,
			width: 350,
			modal: true,
			close: function() {
				$('#boardDiv').show();
			},
			buttons: {
        		"Open": openPage,
				Cancel: function() {
	        		$('#dialogDiv').dialog( "close" );
		   	    }
	   		},
	    });

		deactivateBoard();
	}



	function undoButtonClicked() {
		ALL_STROKES.pop();

		clear();
		drawAllStrokes();
	}

	function line1ButtonClicked() {
		clearLineBorder();
		$('#line1Button').css('border','solid 2px');
		lineWidth = 2;
	}



	function line2ButtonClicked() {
		clearLineBorder();
		$('#line2Button').css('border','solid 2px');
		lineWidth = 5;
	}



	function line3ButtonClicked() {
		clearLineBorder();
		$('#line3Button').css('border','solid 2px');
		lineWidth = 8;
	}


function moveCanvasUPClicked() {

	scrollBoard({preventDefault : () => {}, deltaY: 20 });

}

function moveCanvasDOWNClicked() {

	scrollBoard({preventDefault : () => {}, deltaY: -20 });

}


function selectButtonClicked() {
	activateBoard();
	blueButtonClicked();

	switch (selectState) {

		// normal state
		case 0:
			disableBar();
			$('#selectButton').attr('disabled', false);
			selectState = 1;
			$('#selectButton').html('Copy');
		break;


		// waiting for second corner
		case 2:
			selectState = 0;
			$('#selectButton').html('Select');
			enableBar();
		break;

		// waiting for copy
		case 1:
		case 3:

			// copy content

			localStorage.setItem('board-clipboard', JSON.stringify( getSelectedStrokes(selectedStrokes) ));

			copiedSelectedStrokes = selectedStrokes;
			selectedCenter = centerOfStrokes(copiedSelectedStrokes);
			selectedStrokes = [];
			selectState = 0;
			$('#selectButton').html('Select');
			enableBar();
			clear();
			drawAllStrokes(0, canvasDeltaPosition);


		break;

	}
}







function pastButtonClicked() {
	activateBoard();
	blueButtonClicked();
	disableBar();
	pastSelectedStrokes = true;

	copiedSelectedStrokes = JSON.parse(window.localStorage.getItem('board-clipboard')); 
}





function playbackButtonClicked() {
	clear();
	for (var i = 0; i < ALL_STROKES.length; i++) {
		let s = ALL_STROKES[i];

		((stroke)=>{
			setTimeout(()=>{
				drawStroke(stroke);
//				console.log(stroke);
			}, i*100);
		})(ALL_STROKES[i]);

	}
}



function helpButtonClicked() {




   $('#helpDiv').dialog({
      height: 600,
      width: 600,
      modal: true,
      buttons: {
        Cancel: function() {
          $('#helpDiv').dialog( "close" );
        },
        Ok : function() {
          $('#helpDiv').dialog( "close" );









    showHelp($('#clearButton'), '\
CLick here to clear the entire board\
   	',()=>{

    showHelp($('#drawButton'), ' \
Click here to activate the drawing mode. Without the drawing mode activates, you can use the page normally. Once activated, \
the drawing mode, the page will be frozen and you can overlay the strokes on top of it. \
    ',()=>{

    showHelp($('#eraseButton'), '\
Click here to select the eraser. Drag to erase parts of strokes or shift click to erase complete strokes at once. <br> \
Use the mouse wheel to increase the size of the eraser.\
   	' ,()=>{

    showHelp($('#colorPickerDiv'), '\
Click here to pick a color to paint\
   	',()=>{

    showHelp($('#loadButton'), '\
Click here to load an applet page. The applet will be displayed in the board space and you can either use the applet or draw on top of it. \
   	',()=>{

    showHelp($('#undoButton'), '\
Click here to erase the last drawn stroke. \
    ',()=>{

    showHelp($('#lineWidthDiv'), '\
Click here to choose the line thickness \
    ',()=>{
              
    showHelp($('#saveCanvasButton'), '\
Use this button to save what is currently drawn on the canvas. The file is a JSON file that can be restored here. To save an image, you can use the browser to take a snapshot \
    ',()=>{
              
    showHelp($('#loadCanvasButton'), '\
Use this button to load a saved canvas.\
    ',()=>{
              
    showHelp($('#moveUpDownCanvasDiv'), '\
Use these buttons to move the canvas up or down to get more space to draw \
    ',()=>{
              
    showHelp($('#selectButton'), '\
Click here to select strokes to be copied. After clicking here, you can click and drag on the canvas to select the strokes that are inside the selection rectangle. <br> \
You can also simply click on the stroke you want to select. To select multiple strokes or regions, press shift while you click or drag. After the selection, click here again (copy) to copy to the strokes.  \
    ',()=>{
              
    showHelp($('#pastButton'), '\
Click here to past the last copied strokes. After clicking here, you can move the pasted strokes and click to position them on the canvas. \
    ',()=>{
              
    showHelp($('#playbackButton'), '\
Click here to animate the history of your canvas. \
    ',()=>{
              
    showHelp($('#helpButton'), '\
Hello again! You already clicked me! %-) \
    ',()=>{
              

    }, null, 10);

    }, null, 10);

    }, null, 10);

    }, null, 10);

    }, null, 10);
      
    }, null, 10);

    }, null, 10);
      
    }, null, 10);

    }, null, 10);
      
    });

    });

    });
      
    });

    });





        } // dialog
      } 
    });



}