	function copyPos(pos) {
		let newPos = [];
		for (var i = 0; i < pos.length; i++) {
			newPos.push([pos[i][0], pos[i][1]]);
		}

		return newPos;
	}

	function displaceStrokes(strokeSet, x, y) {
		for (var i = 0; i < strokeSet.length; i++) {
			let s = strokeSet[i];

			for (var j = 0; j < s.pos.length; j++) {
				s.pos[j][0] += x;
				s.pos[j][1] += y;
			}

		}		
	}


	function getSelectedStrokes(selected) {
		newStrokes = [];

		for (var i = 0; i < selected.length; i++) {
			let s = ALL_STROKES[selected[i]];
			let newPos = copyPos(s.pos);
			newStrokes.push({color : s.color, width : s.width, pos:newPos});
		}

		return newStrokes;
	}

	function centerOfStrokes(selected) {

		var cx = 0.0;
		var cy = 0.0;
		var n = 0;

		for (var i = 0; i < selected.length; i++) {
			let s = ALL_STROKES[selected[i]];

			for (var j = 0; j < s.pos.length; j++) {
				let x = s.pos[j][0];
				let y = s.pos[j][1];

				cx += x;
				cy += y;
				n++;
			}			
		}

		return [cx/n, cy/n];
	}


	function selectIndexStrokes(P1, P2) {

		selectedStrokes = [];

		for (var i = 0; i < ALL_STROKES.length; i++) {
			let s = ALL_STROKES[i];

			includeThis = true;
			for (var j = 0; j < s.pos.length; j++) {
				let x = s.pos[j][0];
				let y = s.pos[j][1];

				if (P1[0]<P2[0]) {
					includeThis &=  (x>P1[0])&&(x<P2[0]) 
				} else {
					includeThis &=  (x>P2[0])&&(x<P1[0]) 
				}

				if (P1[1]<P2[1]) {
					includeThis &=  (y>P1[1])&&(y<P2[1]) 
				} else {
					includeThis &=  (y>P2[1])&&(y<P1[1]) 
				}


			}

			if (includeThis) {
				selectedStrokes.push(i);
			}
		}

		return selectedStrokes;
	}



	function deactivateBoard() {
		$('#drawButton').html("Draw");

		$('#boardDiv').css('pointer-events','none');

		boardActive = false;

		$('#boardDiv').css('cursor', 'auto');
	}


	function activateBoard() {
		$('#drawButton').html("Use page");

		$('#boardDiv').css('pointer-events','auto');

		boardActive = true;

		$('#boardDiv').css('cursor', "url('/marker.png')");
	}




	function clearColorBorders() {
		$('#eraseButton').css('border','solid 0px');
		$('#blueButton').css('border','solid 0px');
		$('#redButton').css('border','solid 0px');
		$('#greenButton').css('border','solid 0px');
		$('#yellowButton').css('border','solid 0px');
		$('#cyanButton').css('border','solid 0px');
		$('#brownButton').css('border','solid 0px');
		$('#magentaButton').css('border','solid 0px');
		$('#grayButton').css('border','solid 0px');
		$('#whiteButton').css('border','solid 0px');
		$('#blackButton').css('border','solid 0px');
	}




	function handleFileSelect(e) {
	    console.log(e);

	    var files = e.target.files;
	    if (files.length < 1) {
	        alert('select a file...');
	        return;
	    }
	    var file = files[0];
	    var reader = new FileReader();
	    reader.onload = onFileLoaded;
	    reader.readAsText(file);
	}



	function clearLineBorder() {
		$('#line1Button').css('border','solid 0px');
		$('#line2Button').css('border','solid 0px');
		$('#line3Button').css('border','solid 0px');
	}



	function localStoreCanvasForPage(page) {
		localStorage.setItem('board-'+page, JSON.stringify( ALL_STROKES ));		
	}


	function localLoadCanvasForPage(page) {
		ALL_STROKES = JSON.parse(window.localStorage.getItem('board-'+page)); 
		if (ALL_STROKES == null)
			ALL_STROKES = [];
	}


	function openPage() {

		clear();

		localStoreCanvasForPage(currentPage);

		currentPage = $('#selectPage').val();


		if (currentPage == 'WebApp')
			currentPage = prompt('Past URL here','http://');


		localLoadCanvasForPage(currentPage);

		loadCurrentPage();

		drawAllStrokes();


	}



	function loadCurrentPage() {


		$('#pageFrame').attr('src', currentPage );

		$('#dialogDiv').dialog( "close" );
	}





function displaceStroke(s, dy) {
	if (s != 0) {
		
		for (var j = 0; j < s.pos.length; j++) {
			s.pos[j][1] += dy;
		}
	}

}



function displaceAllStrokes(dy) {

	for (var i = 0; i < ALL_STROKES.length; i++) {
		let s = ALL_STROKES[i];
		displaceStroke(s, dy);
	}

}




function drawStroke(s, selected = 0, dx = 0, dy = 0) {
	if (s != 0) {
		
		stroke(s.color);
		strokeWeight(s.width);

		for (var j = 1; j < s.pos.length; j++) {
			let px = s.pos[j-1][0];
			let py = s.pos[j-1][1];
			let x = s.pos[j][0];
			let y = s.pos[j][1];

			line(px+dx, py+dy, x+dx, y+dy);

			if (selected) {
				stroke('black');
				strokeWeight(10);
				point(x,y+dy)
				stroke(s.color);
				strokeWeight(s.width);
			}
		}
	}

}

function drawSelectedStrokes(selected, x, y) {

	for (var i = 0; i < selected.length; i++) {
		let s = ALL_STROKES[selected[i]];
		drawStroke(s, 0, x, y);
	}

}


function drawAllStrokes(dx = 0, dy = 0) {

	for (var i = 0; i < ALL_STROKES.length; i++) {
		let s = ALL_STROKES[i];
		drawStroke(s, selectedStrokes.includes(i), dx, dy);
	}

}


function drawStrokes(strokes, dx = 0, dy = 0) {

	for (var i = 0; i < strokes.length; i++) {
		let s = strokes[i];
		drawStroke(s, selectedStrokes.includes(i), dx, dy);
	}

}





/**
* Returns the strokes that are close to the point centerX , centerY
* within a radius R
* <p>
* The function selects the strokes from the global array ALL_STROKES
*
* @param  centerX  X coordinate of he center of the circle
* @param  centerY  Y coordinate of he center of the circle
* @param  R        Circle radius
* @return 
* @see
* @extern          ALL_STROKES
*/
function selectIndexStrokesNear(centerX, centerY, R) {

	var selectedStrokes = [];

	for (var i = 0; i < ALL_STROKES.length; i++) {

		let s = ALL_STROKES[i];

		let NPoints = s.pos.length;

		var touches = false;
		for (var j = 0; j < NPoints; j++) {
			let p = s.pos[j];

			touches |= isInsideCircle(p[0], p[1], centerX, centerY, R);

		}

		if (touches) {
			selectedStrokes.push(i);
		}
	}

	return selectedStrokes;
}







/**
* Removes any stroke that have at least one vertex inside the 
* circle of radius R and is centered at centerX, centerY
* <p>
* The function removed the strokes from all strokes present in the 
* global array ALL_STROKES.
*
* @param  centerX  X coordinate of he center of the circle
* @param  centerY  Y coordinate of he center of the circle
* @param  R        Circle radius
* @return 
* @see
* @extern          ALL_STROKES
*/
function removeStrokesAt(centerX, centerY, R) {

	var newALL_STROKES = [];

	for (var i = 0; i < ALL_STROKES.length; i++) {

		let s = ALL_STROKES[i];

		let NPoints = s.pos.length;

		var touches = false;
		for (var j = 0; j < NPoints; j++) {
			let p = s.pos[j];

			touches |= isInsideCircle(p[0], p[1], centerX, centerY, R);

		}

		if (!touches) {
			newALL_STROKES.push(s);
		}
	}

	ALL_STROKES = newALL_STROKES;
}




/**
* Removes the vertices and segments within a radius R of a point.
* This function takes the center and radius of a circle and removes
* all the segments that would lie inside of it, creating vertices when
* necessary
* <p>
* The function removed the segments from all strokes present in the 
* global array ALL_STROKES.
*
* @param  centerX  X coordinate of he center of the circle
* @param  centerY  Y coordinate of he center of the circle
* @param  R        Circle radius
* @return 
* @see
* @extern          ALL_STROKES
*/
function removePoints(centerX, centerY, R) {

	var newALL_STROKES = [];

	for (var i = 0; i < ALL_STROKES.length; i++) {

		let s = ALL_STROKES[i];

		var newStroke = {color:s.color, width:s.width, pos:[]};

		let NPoints = s.pos.length;

		var p0Inside;
		var p1Inside;

		for (var j = 1; j < NPoints; j++) {

			let p0 = [s.pos[j-1][0], s.pos[j-1][1]];
			let p1 = [s.pos[  j][0], s.pos[  j][1]];

			p0Inside = isInsideCircle(s.pos[j-1][0], s.pos[j-1][1], centerX, centerY, R);
			p1Inside = isInsideCircle(s.pos[  j][0], s.pos[  j][1], centerX, centerY, R);


			if (!p0Inside && !p1Inside) {

				let P = intersectLineCircle(p0, p1, [centerX, centerY], R);

				if (P.length == 2) {

					if (P[0] && P[1]) {
						
						newStroke.pos.push(p0);

						newStroke.pos.push(P[1]);

						newALL_STROKES.push(newStroke);


						newStroke = {color:s.color, width:s.width, pos:[]};

						newStroke.pos.push(P[0]);

						newStroke.pos.push(p1);



					} else {
						console.log('deu merda 2');
					}


				} else {
					newStroke.pos.push(p0);
				}
			}








			if (!p0Inside && p1Inside) {
				newStroke.pos.push(p0);

				let P = intersectLineCircle(p0, p1, [centerX, centerY], R);
				if (P[0]) {
					newStroke.pos.push(P[0]);
				} else {
					newStroke.pos.push([(p0[0]+p1[0])/2, (p0[1]+p1[1])/2]);
				}

				newALL_STROKES.push(newStroke);

				newStroke = {color:s.color, width:s.width, pos:[]};

				if (P.length != 1) {
					console.log('deu merda 1');
				}
			}










			if (p0Inside && p1Inside) {
			}











			if (p0Inside && !p1Inside) {
				let P = intersectLineCircle(p0, p1, [centerX, centerY], R);
				if (P[0]) {
					newStroke.pos.push(P[0]);
				} else {
					newStroke.pos.push([(p0[0]+p1[0])/2, (p0[1]+p1[1])/2]);
				}
			}


		} // for each s.pos		


		if (!isInsideCircle(s.pos[NPoints-1][0], s.pos[NPoints-1][1], centerX, centerY, R)) {
			newStroke.pos.push(s.pos[NPoints-1]);
		}

		if (newStroke.pos.length > 1)
			newALL_STROKES.push(newStroke);

	}

//	console.log(newALL_STROKES);

	ALL_STROKES = newALL_STROKES;

}




function saveJSONBoard(STROKES, page) {

	let fileName = prompt('Type the name of the file','canvas.json');

	uriContent = "data:application/octet-stream," + encodeURIComponent(JSON.stringify({page: page, strokes: STROKES})); 

    var link = document.createElement('a');
    link.download = fileName;
    link.href = 'data:,' + uriContent;
    link.click();


//	location.href = uriContent


}





function loadJSONBoard(content) {
	let board = JSON.parse(content);

	return board;
}





function disableBar() {
	$('#clearButton').attr('disabled', true);
	$('#drawButton').attr('disabled', true);
	$('#loadButton').attr('disabled', true);
	$('#selectButton').attr('disabled', true);
	$('#pastButton').attr('disabled', true);
	$('#blueButton').css({'pointer-events':'none','opacity': '0.5'});
	$('#redButton').css({'pointer-events':'none','opacity': '0.5'});
	$('#greenButton').css({'pointer-events':'none','opacity': '0.5'});
	$('#yellowButton').css({'pointer-events':'none','opacity': '0.5'});
	$('#cyanButton').css({'pointer-events':'none','opacity': '0.5'});
	$('#brownButton').css({'pointer-events':'none','opacity': '0.5'});
	$('#magentaButton').css({'pointer-events':'none','opacity': '0.5'});
	$('#grayButton').css({'pointer-events':'none','opacity': '0.5'});
	$('#whiteButton').css({'pointer-events':'none','opacity': '0.5'});
	$('#blackButton').css({'pointer-events':'none','opacity': '0.5'});
	$('#undoButton').css({'pointer-events':'none','opacity': '0.5'});
	$('#line1Button').css({'pointer-events':'none','opacity': '0.5'});
	$('#line2Button').css({'pointer-events':'none','opacity': '0.5'});
	$('#line3Button').css({'pointer-events':'none','opacity': '0.5'});
	$('#saveCanvasButton').css({'pointer-events':'none','opacity': '0.5'});
	$('#loadCanvasButton').css({'pointer-events':'none','opacity': '0.5'});
	$('#moveCanvasUPButton').css({'pointer-events':'none','opacity': '0.5'});
	$('#moveCanvasDOWNButton').css({'pointer-events':'none','opacity': '0.5'});
}

function enableBar() {
	$('#clearButton').attr('disabled', false);
	$('#drawButton').attr('disabled', false);
	$('#loadButton').attr('disabled', false);
	$('#selectButton').attr('disabled', false);
	$('#pastButton').attr('disabled', false);
	$('#blueButton').css({'pointer-events':'auto','opacity': '1.0'});
	$('#redButton').css({'pointer-events':'auto','opacity': '1.0'});
	$('#greenButton').css({'pointer-events':'auto','opacity': '1.0'});
	$('#yellowButton').css({'pointer-events':'auto','opacity': '1.0'});
	$('#cyanButton').css({'pointer-events':'auto','opacity': '1.0'});
	$('#brownButton').css({'pointer-events':'auto','opacity': '1.0'});
	$('#magentaButton').css({'pointer-events':'auto','opacity': '1.0'});
	$('#grayButton').css({'pointer-events':'auto','opacity': '1.0'});
	$('#whiteButton').css({'pointer-events':'auto','opacity': '1.0'});
	$('#blackButton').css({'pointer-events':'auto','opacity': '1.0'});
	$('#undoButton').css({'pointer-events':'auto','opacity': '1.0'});
	$('#line1Button').css({'pointer-events':'auto','opacity': '1.0'});
	$('#line2Button').css({'pointer-events':'auto','opacity': '1.0'});
	$('#line3Button').css({'pointer-events':'auto','opacity': '1.0'});
	$('#saveCanvasButton').css({'pointer-events':'auto','opacity': '1.0'});
	$('#loadCanvasButton').css({'pointer-events':'auto','opacity': '1.0'});
	$('#moveCanvasUPButton').css({'pointer-events':'auto','opacity': '1.0'});
	$('#moveCanvasDOWNButton').css({'pointer-events':'auto','opacity': '1.0'});
}